| AI Engine API User Guide (AIE-API) 2025.2

Loading...
Searching...
No Matches
Classes
Architecture helpers
Uility functions and classes

## Overview

## Classes
struct | aie::arch
| Structure used to represent the AIE architecture being compiled against. More...

## Class Documentation

## ◆ aie::arch

struct aie::arch

Structure used to represent the AIE architecture being compiled against.

### Public Types
enum | ArchGeneration : unsigned
| An enum defining available AIE generations, which are defined as: More...
enum | ArchVersion : unsigned
| An enum defining available AIE architectures. More...
### Static Public Member Functions
template<typename... T> requires (std::is_same_v<T, ArchGeneration> && ...)
static constexpr bool | is (T... gens)
| Checks if the current AIE architecture version against the supplied generation pack.
template<typename... T> requires (std::is_same_v<T, ArchVersion> && ...)
static constexpr bool | is (T... vs)
| Checks if the current AIE architecture version against the supplied pack.
### Static Public Attributes
static constexpr ArchGeneration | generation = ArchGeneration(__AIE_ARCH__ / 10)
| Represents the current AIE generation.
static constexpr ArchVersion | version = ArchVersion(__AIE_ARCH__)
| Represents the current AIE architecture version.

#### Member Enumeration Documentation

## ◆ ArchGeneration

enum aie::arch::ArchGeneration : unsigned

An enum defining available AIE generations, which are defined as:

Enumerator
Gen1 | AIE.
Gen2 | AIE-ML/XDNA1, XDNA2, AIE-MLv2.

## ◆ ArchVersion

enum aie::arch::ArchVersion : unsigned

An enum defining available AIE architectures.

Enumerator
AIE |
AIE_ML |
XDNA2 |
AIE_MLv2 |

#### Member Function Documentation

## ◆ is() [1/2]

template<typename... T>
requires (std::is_same_v<T, ArchGeneration> && ...)

static constexpr bool aie::arch::is | ( | T... | gens | ) |
| inline static constexpr

Checks if the current AIE architecture version against the supplied generation pack.

Parameters

  gens | A pack of ArchGenerations to test the current version against

## ◆ is() [2/2]

template<typename... T>
requires (std::is_same_v<T, ArchVersion> && ...)

static constexpr bool aie::arch::is | ( | T... | vs | ) |
| inline static constexpr

Checks if the current AIE architecture version against the supplied pack.

Parameters

  vs | A pack of ArchVersions to test the current version against

#### Member Data Documentation

## ◆ generation

ArchGeneration aie::arch::generation = ArchGeneration(__AIE_ARCH__ / 10)
| static constexpr

Represents the current AIE generation.

## ◆ version

ArchVersion aie::arch::version = ArchVersion(__AIE_ARCH__)
| static constexpr

Represents the current AIE architecture version.